%define gtk2_version 2.11.3
%define dbus_glib_version 0.70
%define dbus_version 0.90
%define gnome_keyring_version 2.21.92
%define gconf2_version 2.14.0
%define libnotify_version 0.2.1

%define po_package gnome-session-2.0

Summary: GNOME session manager
Name: gnome-session
Version: 2.28.0
Release: 18%{?dist}
URL: http://www.gnome.org
Source0: http://download.gnome.org/sources/gnome-session/2.28/%{name}-%{version}.tar.bz2
# latest upstream translations
# see https://bugzilla.redhat.com/show_bug.cgi?id=553603
Source3: as.po

License: GPLv2+
Group: User Interface/Desktops
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires: system-logos
# required to get gconf-sanity-check-2 in the right place
Requires: GConf2-gtk >= %{gconf2_version}
# Needed for gnome-settings-daemon
Requires: control-center

# pull in dbus-x11, see bug 209924
Requires: dbus-x11

# we need an authentication agent in the session
Requires: polkit-gnome
# and we want good defaults
Requires: polkit-desktop-policy

## we conflict with gdm that contains the GNOME gdm xsession
Conflicts: gdm < 1:2.6.0.8-5

BuildRequires: gtk2-devel >= %{gtk2_version}
BuildRequires: dbus-devel >= %{dbus_version}
BuildRequires: dbus-glib-devel >= %{dbus_glib_version}
BuildRequires: gnome-keyring-devel >= %{gnome_keyring_version}
BuildRequires: libnotify-devel >= %{libnotify_version}
BuildRequires: GConf2-devel >= %{gconf2_version}
BuildRequires: GConf2-gtk >= %{gconf2_version}
BuildRequires: gnome-desktop-devel
BuildRequires: pango-devel
BuildRequires: gnome-settings-daemon-devel
BuildRequires: desktop-file-utils
BuildRequires: libXau-devel
BuildRequires: libXrandr-devel
BuildRequires: xorg-x11-xtrans-devel

# this is so the configure checks find /usr/bin/halt etc.
BuildRequires: usermode

BuildRequires: intltool, autoconf, automake
BuildRequires: libtool
BuildRequires: gettext
BuildRequires: libX11-devel libXt-devel
BuildRequires: libXtst-devel
BuildRequires: xmlto
BuildRequires: DeviceKit-power-devel
BuildRequires: gnome-common

# for patch3
BuildRequires: libnotify-devel

Requires(pre): GConf2 >= %{gconf2_version}
Requires(post): GConf2 >= %{gconf2_version}
Requires(preun): GConf2 >= %{gconf2_version}

# https://bugzilla.gnome.org/show_bug.cgi?id=592520
#Patch0: unresponsive-timeout.patch
# https://bugzilla.gnome.org/show_bug.cgi?id=592519
#Patch1: show-lock.patch
# https://bugzilla.gnome.org/show_bug.cgi?id=598211
Patch2: xsmp-stop.patch

# https://bugzilla.gnome.org/show_bug.cgi?id=597030
Patch3: 0001-Add-ability-to-perform-actions-after-a-period-of-idl.patch

# https://bugzilla.gnome.org/show_bug.cgi?id=607094
Patch4: nag-root-user.patch

# https://bugzilla.gnome.org/show_bug.cgi?id=575544
# https://bugzilla.gnome.org/show_bug.cgi?id=613270
# https://bugzilla.redhat.com/622849
Patch5: custom-sessions.patch

# translation updates
# https://bugzilla.redhat.com/show_bug.cgi?id=553594
Patch7: gnome-session-translations.patch

# https://bugzilla.redhat.com/show_bug.cgi?id=589184
Patch8: fix-up-man-page.patch

# https://bugzilla.redhat.com/show_bug.cgi?id=573024
Patch9: drop-no-description.patch

%description
gnome-session manages a GNOME desktop or GDM login session. It starts up
the other core GNOME components and handles logout and saving the session.

%package xsession
Summary: gnome-session desktop file
Group: User Interface/Desktop
Requires: gnome-session = %{version}-%{release}

%description xsession
Desktop file to add GNOME to display manager session menu.

%package custom-session
Summary: A facility to select and store saved sessions
Group: User Interface/Desktop
Requires: gnome-session = %{version}-%{release}

%description custom-session
Installs a 'Custom' entry in the display manager session menu that
lets the user manage multiple saved sessions.

%prep
%setup -q
#%patch0 -p1 -b .unresponsive-timeout
#%patch1 -p1 -b .show-lock
%patch2 -p1 -b .xsmp-stop
%patch3 -p1 -b .max-idle
%patch4 -p1 -b .nag-root-user
%patch5 -p1 -b .custom-sessions

echo "ACLOCAL_AMFLAGS = -I m4" >> Makefile.am

autoreconf -i -f

cp %{SOURCE3} po

%patch7 -p1 -b .translations
%patch8 -p1 -b .fix-up-man-page
%patch9 -p1 -b .drop-no-description

%build

%configure --enable-docbook-docs --docdir=%{_datadir}/doc/%{name}-%{version} --enable-session-selector
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make install DESTDIR=$RPM_BUILD_ROOT
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

desktop-file-install --vendor gnome --delete-original                   \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications			        \
  --add-only-show-in GNOME                                              \
  $RPM_BUILD_ROOT%{_datadir}/applications/*

/bin/rm -f $RPM_BUILD_ROOT%{_datadir}/gnome/autostart/gnome-login-sound.desktop
/bin/rm -f $RPM_BUILD_ROOT%{_datadir}/gnome/shutdown/gnome-logout-sound.sh
/bin/rm -f $RPM_BUILD_ROOT%{_libdir}/gnome-session/helpers/gnome-login-sound

mkdir -p $RPM_BUILD_ROOT%{_datadir}/gnome/autostart

cp AUTHORS COPYING NEWS README $RPM_BUILD_ROOT%{_datadir}/doc/%{name}-%{version}

%find_lang %{po_package}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/gnome-session.schemas >& /dev/null || :

%pre
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/gnome-session.schemas >& /dev/null || :
fi

%preun
if [ "$1" -eq 0 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/gnome-session.schemas >& /dev/null || :
fi

%postun -p /sbin/ldconfig

%files xsession
%defattr(-,root,root)
%{_datadir}/xsessions/gnome.desktop

%files custom-session
%defattr(-,root,root)
%{_datadir}/xsessions/gnome-custom-session.desktop
%{_bindir}/gnome-session-selector
%{_bindir}/gnome-session-custom-session
%{_datadir}/gnome-session/session-selector.ui
%doc %{_mandir}/man*/gnome-session-selector*

%files -f %{po_package}.lang
%defattr(-,root,root)
%doc %dir %{_datadir}/doc/%{name}-%{version}
%doc %{_datadir}/doc/%{name}-%{version}/AUTHORS
%doc %{_datadir}/doc/%{name}-%{version}/COPYING
%doc %{_datadir}/doc/%{name}-%{version}/NEWS
%doc %{_datadir}/doc/%{name}-%{version}/README
%doc %dir %{_datadir}/doc/%{name}-%{version}/dbus
%doc %{_datadir}/doc/%{name}-%{version}/dbus/*
%doc %{_mandir}/man*/gnome-session-properties*
%doc %{_mandir}/man*/gnome-session-save*
%doc %{_mandir}/man*/gnome-session*
%doc %{_mandir}/man*/gnome-wm*
%{_datadir}/applications/gnome-session-properties.desktop
%dir %{_datadir}/gnome-session
%{_datadir}/gnome/autostart
%{_bindir}/gnome-session
%{_bindir}/gnome-session-properties
%{_bindir}/gnome-session-save
%{_bindir}/gnome-wm
%{_sysconfdir}/gconf/schemas/*.schemas
%{_datadir}/gnome-session/gsm-inhibit-dialog.ui
%{_datadir}/gnome-session/session-properties.ui
%{_datadir}/icons/hicolor/*/apps/session-properties.png
%{_datadir}/icons/hicolor/scalable/apps/session-properties.svg
%dir %{_libdir}/gnome-session
%dir %{_libdir}/gnome-session/helpers
%{_libdir}/gnome-session/helpers/*
%{_sysconfdir}/xdg/autostart/gnome-settings-daemon-helper.desktop


%changelog

